function CMain(oData){
    var _bUpdate;
    var _iCurResource = 0;
    var RESOURCE_TO_LOAD = 0;
    var _iState = STATE_LOADING;
    var _oData;
    
    var _oPreloader;
    var _oMenu;
    var _oHelp;
    var _oGame;

    this.initContainer = function(){
        var canvas = document.getElementById("canvas");
        s_oStage = new createjs.Stage(canvas);
        createjs.Touch.enable(s_oStage);

        s_iPrevTime = new Date().getTime();

        s_bMobile = jQuery.browser.mobile;
        if(s_bMobile === false){
            s_oStage.enableMouseOver(20);  
        }

	createjs.Ticker.addEventListener("tick", this._update);
	if(navigator.userAgent.match(/Windows Phone/i)){
                DISABLE_SOUND_MOBILE = true;
        }
        s_oSpriteLibrary  = new CSpriteLibrary();

        //ADD PRELOADER
        _oPreloader = new CPreloader();
    };
    
    this._initSounds = function(){
         if (!createjs.Sound.initializeDefaultPlugins()) {
             return;
         }
         
		 if(navigator.userAgent.indexOf("Opera")>0 || navigator.userAgent.indexOf("OPR")>0){
			 createjs.Sound.alternateExtensions = ["mp3"];
			 createjs.Sound.addEventListener("fileload", createjs.proxy(this.handleFileLoad, this));
			 
			 createjs.Sound.registerSound("./sounds/gameover.ogg", "gameover");     
			 createjs.Sound.registerSound("./sounds/soundtrack.ogg", "soundtrack");
			 createjs.Sound.registerSound("./sounds/matching.ogg", "matching");
			 createjs.Sound.registerSound("./sounds/life_lost.ogg", "life_lost");
		 }else{
			 createjs.Sound.alternateExtensions = ["ogg"];
			 createjs.Sound.addEventListener("fileload", createjs.proxy(this.handleFileLoad, this));
			 
			 createjs.Sound.registerSound("./sounds/gameover.mp3", "gameover");     
			 createjs.Sound.registerSound("./sounds/soundtrack.mp3", "soundtrack");
			 createjs.Sound.registerSound("./sounds/matching.mp3", "matching");
			 createjs.Sound.registerSound("./sounds/life_lost.mp3", "life_lost");
		 }
         

         RESOURCE_TO_LOAD +=4;
    };
    
    this.handleFileLoad = function(){
         _iCurResource++;
         var iPerc = Math.floor(_iCurResource/RESOURCE_TO_LOAD *100);
        _oPreloader.refreshLoader(iPerc);
        
         if(_iCurResource === RESOURCE_TO_LOAD){
            _oPreloader.unload();
            
            if(DISABLE_SOUND_MOBILE === false || s_bMobile === false){
                s_oSoundTrackSnd = playSound("soundtrack",.5,-1);
            }
            
            this.gotoMenu();
         }
    };
    
    this._loadImages = function(){
        s_oSpriteLibrary.init( this._onImagesLoaded,this._onAllImagesLoaded, this );

        s_oSpriteLibrary.addSprite("but_play","./"+Settings.backgroundButton);
        s_oSpriteLibrary.addSprite("but_exit","./"+Settings.exit);
        s_oSpriteLibrary.addSprite("bg_menu","./"+Settings.bgMenu);
        s_oSpriteLibrary.addSprite("msg_box","./"+Settings.msgBox);
        s_oSpriteLibrary.addSprite("game_bg","./"+Settings.bgMenu);


        for(var i=0;i<6;i++){
            var n;
            if(i == 0) n = Settings.symbolFirst;
            if(i == 1) n = Settings.symbolSecond;
            if(i == 2) n = Settings.symbolThird;
            if(i == 3) n = Settings.symbolFourth;
            if(i == 4) n = Settings.symbolFifth;
            if(i == 5) n = Settings.symbolSixth;
            s_oSpriteLibrary.addSprite("elem_"+i,"./"+n);
        }


        s_oSpriteLibrary.addSprite("audio_on","./"+Settings.audioOn);
        s_oSpriteLibrary.addSprite("audio_off","./"+Settings.audioOff);

	    s_oSpriteLibrary.addSprite("life","./"+Settings.life);
        s_oSpriteLibrary.addSprite("highlight","./sprites/highlight.png");

        RESOURCE_TO_LOAD += s_oSpriteLibrary.getNumSprites();
        s_oSpriteLibrary.loadSprites();
    };
    
    this._onImagesLoaded = function(){
        _iCurResource++;
        var iPerc = Math.floor(_iCurResource/RESOURCE_TO_LOAD *100);
        _oPreloader.refreshLoader(iPerc);
        
        if(_iCurResource === RESOURCE_TO_LOAD){
            _oPreloader.unload();
            
            s_oSoundTrackSnd = playSound("soundtrack",.5,-1);
            
            this.gotoMenu();
        }
    };
    
    this._onAllImagesLoaded = function(){
        
    };
    
    this.onAllPreloaderImagesLoaded = function(){
        this._loadImages();
    };
    
    this.preloaderReady = function(){
        this._loadImages();
		
	if(DISABLE_SOUND_MOBILE === false || s_bMobile === false){
            this._initSounds();
        }
		
	_bUpdate = true;
    };
    
    this.gotoMenu = function(){
        _oMenu = new CMenu();
        _iState = STATE_MENU;
    };
    
    this.gotoGame = function(){
        _oGame = new CGame(_oData);   
							
        _iState = STATE_GAME;
    };
    
    this.gotoHelp = function(){
        _oHelp = new CHelp();
        _iState = STATE_HELP;
    };
    
    this.stopUpdate = function(){
        _bUpdate = false;
        createjs.Ticker.paused = true;
        $("#block_game").css("display","block");
    };

    this.startUpdate = function(){
        s_iPrevTime = new Date().getTime();
        _bUpdate = true;
        createjs.Ticker.paused = false;
        $("#block_game").css("display","none");
    };
    
    this._update = function(event){
        if(!_bUpdate){
            return;
        }
        
        var iCurTime = new Date().getTime();
        s_iTimeElaps = iCurTime - s_iPrevTime;
        s_iCntTime += s_iTimeElaps;
        s_iCntFps++;
        s_iPrevTime = iCurTime;
        
        if ( s_iCntTime >= 1000 ){
            s_iCurFps = s_iCntFps;
            s_iCntTime-=1000;
            s_iCntFps = 0;
        }
                
        if(_iState === STATE_GAME){
            _oGame.update();
        }
        
        s_oStage.update(event);

    };
    
    s_oMain = this;
	_oData = oData;
	
    this.initContainer();
}

var s_iCntTime = 0;
var s_iTimeElaps = 0;
var s_iPrevTime = 0;
var s_iCntFps = 0;
var s_iCurFps = 0;

var s_bMobile;
var s_bAudioActive = true;
var s_oSoundTrackSnd;
var s_oDrawLayer;
var s_oStage;
var s_oMain;
var s_oSpriteLibrary;