function CMenu(){
    var _pStartPosAudio;
	var _pStartPosPlay;
	var _oBg;
    var _oButPlay;
    var _oAudioToggle;
    var _oFade;
    var _oTextBack;

    this._init = function(){
        _oBg = createBitmap(s_oSpriteLibrary.getSprite('bg_menu'));
        s_oStage.addChild(_oBg);
        _oTextBack = new CText((CANVAS_WIDTH/2),(CANVAS_HEIGHT/2) - 200,Settings.name,FONT_GAME,'#'+Settings.colorTitle,80);

        _pStartPosPlay = {x:(CANVAS_WIDTH/2),y:CANVAS_HEIGHT - 100};
        var oSprite = s_oSpriteLibrary.getSprite('but_play');
        _oButPlay = new CTextButton(_pStartPosPlay.x,_pStartPosPlay.y,oSprite,TEXT_PLAY,FONT_GAME,"#f1e10b",60);
        _oButPlay.addEventListener(ON_MOUSE_UP, this._onButPlayRelease, this);

        if(DISABLE_SOUND_MOBILE === false || s_bMobile === false){
            var canvas = document.createElement('canvas');
            canvas.width = 143;
            canvas.height = 70;
            var ctx = canvas.getContext("2d");
            ctx.drawImage(s_oSpriteLibrary.getSprite('audio_on'),0,0);
            ctx.drawImage(s_oSpriteLibrary.getSprite('audio_off'),71.5,0);
            _pStartPosAudio = {x: CANVAS_WIDTH - (canvas.height/2)- 10, y: (canvas.height/2) + 10};
            _oAudioToggle = new CToggle(_pStartPosAudio.x,_pStartPosAudio.y,canvas,s_bAudioActive);
            _oAudioToggle.addEventListener(ON_MOUSE_UP, this._onAudioToggle, this);
        }

        _oFade = new createjs.Shape();
        _oFade.graphics.beginFill("black").drawRect(0,0,CANVAS_WIDTH,CANVAS_HEIGHT);
        
        s_oStage.addChild(_oFade);
        
        createjs.Tween.get(_oFade).to({alpha:0}, 1000).call(function(){_oFade.visible = false;});  
		
	var oVerText = new createjs.Text("v2","20px "+FONT_GAME, "#000000");
        oVerText.x = (CANVAS_WIDTH - 20);
        oVerText.y = CANVAS_HEIGHT - 25;
        oVerText.textAlign = "center";
        s_oStage.addChild(oVerText);
		
	this.refreshButtonPos(s_iOffsetX,s_iOffsetY);
    };
    
    this.unload = function(){
        _oButPlay.unload(); 
        _oButPlay = null;
        
        if(DISABLE_SOUND_MOBILE === false || s_bMobile === false){
            _oAudioToggle.unload();
            _oAudioToggle = null;
        }
        
        s_oStage.removeChild(_oBg);
        _oBg = null;
	s_oMenu = null;
    };
    
    this.refreshButtonPos = function(iNewX,iNewY){
	_oButPlay.setPosition(_pStartPosPlay.x + iNewX, _pStartPosPlay.y - iNewY);
		
        if(DISABLE_SOUND_MOBILE === false || s_bMobile === false){
            _oAudioToggle.setPosition(_pStartPosAudio.x - iNewX,iNewY + _pStartPosAudio.y);
        }   
    };
	
    this._onButPlayRelease = function(){
        this.unload();
        
        $(s_oMain).trigger("start_session");
        s_oMain.gotoGame();
    };
    
    this._onAudioToggle = function(){
        createjs.Sound.setMute(s_bAudioActive);
	s_bAudioActive = !s_bAudioActive;
    };
	
    s_oMenu = this;
    
    this._init();
}

var s_oMenu = null;